datablock AudioProfile(BR551Sound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55MagInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55MagOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55UseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(BR55Casing)
{
	shapeFile = "./MA5Cshell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(BR55flashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./brMuzFlare";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BR55FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BR55flashParticle";

   uiName = "BR55 Flash";
};

//bullet trail effects
datablock ParticleData(BR55bulletTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.3 0.0 0.8";
	colors[1]     = "0.3 0.3 0.0 0.6";
	colors[2]     = "0.3 0.3 0.0 0.0";
	sizes[0]      = 0.06;
	sizes[1]      = 0.06;
	sizes[2]	  = 0.01;
	times[0]      = 0.0;
	times[1]	  = 0.9;
	times[2]      = 1.0;

	useInvAlpha = false;
};

AddDamageType("BR55",   '<bitmap:add-ons/Weapon_BR55/CI_BR55> %1',    '%2 <bitmap:add-ons/Weapon_BR55/CI_BR55> %1',0.2,1);
datablock ProjectileData(BR55Projectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::BR55;
   radiusDamageType    = $DamageType::BR55;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "BR55 Bullet";
};

//////////
// item //
//////////
datablock ItemData(BR55Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BR55_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "BR55 Battle Rifle";
	iconName = "./UI_BR55";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = BR55Image;
	canDrop = true;

	maxAmmo = 36;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BR55Image)
{
   // Basic Item properties
   shapeFile = "./BR55.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BR55Item;
   ammo = " ";
   projectile = BR55Projectile;
   projectileType = Projectile;

	casing = BR55Casing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BR55Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= BR55UseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire1";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire1";
	stateTransitionOnTimeout[2]     	= "Fire2";
	stateTimeoutValue[2]            	= 0.07;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= BR55FlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= BR551Sound;
	
		stateName[3]                    	= "Fire2";
	stateTransitionOnTimeout[3]     	= "Fire3";
	stateTimeoutValue[3]            	= 0.07;
	stateFire[3]                    	= true;
	stateAllowImageChange[3]        	= false;
	stateSequence[3]                	= "fire";
	stateScript[3]                  	= "onFire";
	stateEjectShell[3]       	  	= true;
	stateEmitter[3]				= BR55FlashEmitter;
	stateEmitterTime[3]			= 0.05;
	stateEmitterNode[3]			= "muzzleNode";
	stateWaitForTimeout[3]			= true;
	stateSound[3]				= BR551Sound;
	
		stateName[4]                    	= "Fire3";
	stateTransitionOnTimeout[4]     	= "Delay";
	stateTimeoutValue[4]            	= 0.1;
	stateFire[4]                    	= true;
	stateAllowImageChange[4]        	= false;
	stateSequence[4]                	= "fire";
	stateScript[4]                  	= "onFire";
	stateEjectShell[4]       	  	= true;
	stateEmitter[4]				= BR55FlashEmitter;
	stateEmitterTime[4]			= 0.05;
	stateEmitterNode[4]			= "muzzleNode";
	stateWaitForTimeout[4]			= true;
	stateSound[4]				= BR551Sound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.01;
	stateEmitter[7]				= gunSmokeEmitter;
	stateEmitterTime[7]			= 0.01;
	stateEmitterNode[7]			= "muzzleNode";
	
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.76;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= BR55MagOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.20;
	stateSound[11]				= BR55MagInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateEmitter[14]			= gunSmokeEmitter;
	stateEmitterTime[14]			= 0.1;
	stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.1;
	stateTransitionOnTimeout[14]		= "Ready";
	
	stateName[15] 				= "ReloadSmoke";
	stateEmitter[15]			= gunSmokeEmitter;
	stateEmitterTime[15]			= 0.1;
	stateEmitterNode[15]			= "muzzleNode";
	stateTimeoutValue[15]			= 0.1;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
};

function BR55Image::onFire(%this,%obj,%slot)
{
	%projectile = BR55Projectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.00005;
	}
	else
	{
		%spread = 0.001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	//%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


function BR55Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function BR55Image::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function BR55Image::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 36;
	%obj.setImageAmmo(%slot,1);
}


//### Mount on player

datablock ShapeBaseImageData(BR55BackImage)
{
  shapeFile = "./BR55_Back.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "-0.4 -0.35 0";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("65 0 90");
  armReady = false;
  doColorShift = false;
};

function BR55Image::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "BR55BackImage") { %obj.unMountImage(1); }
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function BR55Image::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(BR55BackImage,1);
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function BR55Item::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(BR55BackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package BR55Package
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "BR55Item")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "BR55BackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(BR55Package);